## fpzip 1.3.0

=== CMakeLists.txt ===
if(WIN32)
  cmake_minimum_required(VERSION 3.4)
else()
  cmake_minimum_required(VERSION 3.1)
endif()

# Fail immediately if not using an out-of-source build
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif()

#------------------------------------------------------------------------------#
# Parse version number from fpzip.h
#------------------------------------------------------------------------------#
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/include/fpzip.h _fpzip_h_contents)
string(REGEX REPLACE ".*#define[ \t]+FPZIP_VERSION_MAJOR[ \t]+([0-9]+).*"
     "\\1" FPZIP_VERSION_MAJOR ${_fpzip_h_contents})
string(REGEX REPLACE ".*#define[ \t]+FPZIP_VERSION_MINOR[ \t]+([0-9]+).*"
    "\\1" FPZIP_VERSION_MINOR ${_fpzip_h_contents})
string(REGEX REPLACE ".*#define[ \t]+FPZIP_VERSION_PATCH[ \t]+([0-9]+).*"
    "\\1" FPZIP_VERSION_PATCH ${_fpzip_h_contents})
set(FPZIP_VERSION
  "${FPZIP_VERSION_MAJOR}.${FPZIP_VERSION_MINOR}.${FPZIP_VERSION_PATCH}")

project(FPZIP VERSION ${FPZIP_VERSION})

#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/fpzip
  CACHE STRING "Installation CMake subdirectory")

list(INSERT CMAKE_MODULE_PATH 0 "${FPZIP_SOURCE_DIR}/cmake")
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${FPZIP_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${FPZIP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${FPZIP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()

#------------------------------------------------------------------------------#
# Top level options
#------------------------------------------------------------------------------#

# Windows (Visual Studio) specific options
if(MSVC)
  # Use this to get a usable export library when building a DLL on Windows
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

  # Silence extraneous Visual Studio specific warnings
  add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS /wd4146 /wd4305)
endif()

# Suggest C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

if(MSVC OR MINGW)
  set(CMAKE_C_STANDARD 90)
endif()

message(STATUS "Compiling with C standard: ${CMAKE_C_STANDARD}")

# Suggest C++98
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 98)
endif()
message(STATUS "Compiling with C++ standard: ${CMAKE_CXX_STANDARD}")

include(CMakeDependentOption)

# Typically you'd always be able to enable shared libraries but default
# configurations with the Cray toolchain will explicitly disable shared lib
# support and only allow static libs.  Making this a cmake_dependent_option
# will ensure that shared library support will be disabled if the system does
# not support it.

# Setup shared library / -fPIC stuff
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Whether or not to build shared libraries" ON
  "SHARED_LIBS_SUPPORTED" OFF)

# PIC is always on for shared libs.  This allows it to be selectable for
# static libs.
if(DEFINED FPZIP_ENABLE_PIC)
  set(FPZIP_ENABLE_PIC_DEFAULT ${FPZIP_ENABLE_PIC})
elseif(DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set(FPZIP_ENABLE_PIC_DEFAULT ${CMAKE_POSITION_INDEPENDENT_CODE})
else()
  set(FPZIP_ENABLE_PIC_DEFAULT ${SHARED_LIBS_SUPPORTED})
endif()
cmake_dependent_option(FPZIP_ENABLE_PIC
  "Build with Position Independent Code" ${FPZIP_ENABLE_PIC_DEFAULT}
  "SHARED_LIBS_SUPPORTED" OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ${FPZIP_ENABLE_PIC})

# Compile-time options

set(FPZIP_BLOCK_SIZE 4096 CACHE STRING "I/O unit in bytes")
set_property(CACHE FPZIP_BLOCK_SIZE PROPERTY STRINGS "4096")

set(FPZIP_FP FPZIP_FP_FAST CACHE STRING "Floating-point arithmetic")
set_property(CACHE FPZIP_FP PROPERTY STRINGS "FPZIP_FP_FAST;FPZIP_FP_SAFE;FPZIP_FP_EMUL;FPZIP_FP_INT")

option(FPZIP_WITH_REINTERPRET_CAST "Convert to int via reinterpret_cast" OFF)

option(FPZIP_WITH_UNION "Convert to int via union" OFF)

# Handle compile-time macros

list(APPEND fpzip_public_defs FPZIP_FP=${FPZIP_FP})
list(APPEND fpzip_private_defs FPZIP_BLOCK_SIZE=${FPZIP_BLOCK_SIZE})

if((DEFINED FPZIP_INT64) AND (DEFINED FPZIP_INT64_SUFFIX))
  list(APPEND fpzip_public_defs FPZIP_INT64=${FPZIP_INT64})
  list(APPEND fpzip_public_defs FPZIP_INT64_SUFFIX=${FPZIP_INT64_SUFFIX})
endif()

if((DEFINED FPZIP_UINT64) AND (DEFINED FPZIP_UINT64_SUFFIX))
  list(APPEND fpzip_public_defs FPZIP_UINT64=${FPZIP_UINT64})
  list(APPEND fpzip_public_defs FPZIP_UINT64_SUFFIX=${FPZIP_UINT64_SUFFIX})
endif()

# Link libm only if necessary
include(CheckCSourceCompiles)
check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_MATH)
if(NOT HAVE_MATH)
  set(CMAKE_REQUIRED_LIBRARIES m)
  check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_LIBM_MATH)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(NOT HAVE_LIBM_MATH)
    message(FATAL_ERROR "Unable to use C math library functions (with or without -lm)")
  endif()
endif()

#------------------------------------------------------------------------------#
# Add source code
#------------------------------------------------------------------------------#
include(CTest)
if(BUILD_TESTING)
  enable_testing()
endif()

set(FPZIP_LIBRARY_PREFIX "" CACHE STRING
  "Prefix to prepend to the output library name")
mark_as_advanced(FPZIP_LIBRARY_PREFIX)

add_subdirectory(src)

option(BUILD_ALL "Build all subdirectories" OFF)
if(BUILD_ALL)
  set(BUILD_UTILITIES ON CACHE BOOL "Build command-line utilities for fpzip" FORCE)
  set(BUILD_TESTING ON CACHE BOOL "Build tests" FORCE)
endif()

option(BUILD_UTILITIES "Build command-line utilities for fpzip" ON)
if(BUILD_UTILITIES)
  add_subdirectory(utils)
endif()

option(BUILD_TESTING "Build tests" ON)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

#------------------------------------------------------------------------------#
# Header install
#------------------------------------------------------------------------------#
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

#------------------------------------------------------------------------------#
# Build type: one of None, Debug, Release, RelWithDebInfo, MinSizeRel
#------------------------------------------------------------------------------#
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
endif()

#------------------------------------------------------------------------------#
# Packaging
#------------------------------------------------------------------------------#

# Add all targets to the build-tree export set
export(TARGETS fpzip NAMESPACE fpzip::
  FILE "${PROJECT_BINARY_DIR}/fpzip-targets.cmake")

configure_file(fpzip-config.cmake.in
  "${PROJECT_BINARY_DIR}/fpzip-config.cmake" @ONLY)
configure_file(fpzip-config-version.cmake.in
  "${PROJECT_BINARY_DIR}/fpzip-config-version.cmake" @ONLY)

# Install the fpzip-config.cmake and fpzip-config-version.cmake
install(FILES
  "${PROJECT_BINARY_DIR}/fpzip-config.cmake"
  "${PROJECT_BINARY_DIR}/fpzip-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_CMAKEDIR}")

# Install the export set for use with the install-tree
install(EXPORT fpzip-targets NAMESPACE fpzip::
  DESTINATION "${CMAKE_INSTALL_CMAKEDIR}")

=== Makefile ===
# see Config file for compile-time settings
include Config

MAKEFLAGS += --no-print-directory


# default: build all targets enabled in Config
all:
	@echo $(LIBRARY)
	@cd src; $(MAKE) clean $(LIBRARY)
ifneq ($(BUILD_UTILITIES),0)
	@cd utils; $(MAKE) clean all
endif
ifneq ($(BUILD_TESTING),0)
	@cd tests; $(MAKE) clean all
endif


# run basic regression tests
test:
	@cd tests; $(MAKE) test


# clean all
clean:
	@cd src; $(MAKE) clean
	@cd utils; $(MAKE) clean
	@cd tests; $(MAKE) clean

=== src/CMakeLists.txt ===
set(fpzip_source
  codec.h
  error.cpp
  fpe.h fpe.inl
  front.h
  pccodec.h pccodec.inl
  pcdecoder.h pcdecoder.inl
  pcencoder.h pcencoder.inl
  pcmap.h pcmap.inl
  rcdecoder.cpp rcdecoder.h rcdecoder.inl
  rcencoder.cpp rcencoder.h rcencoder.inl
  rcmodel.h
  rcqsmodel.cpp rcqsmodel.h rcqsmodel.inl
  read.cpp read.h
  types.h
  version.cpp
  write.cpp write.h)

add_library(fpzip ${fpzip_source})
add_library(fpzip::fpzip ALIAS fpzip)

if(HAVE_LIBM_MATH)
  target_link_libraries(fpzip PRIVATE m)
endif()

if(WIN32 AND BUILD_SHARED_LIBS)
  # Define FPZIP_SOURCE when compiling libfpzip to export symbols to Windows DLL
  list(APPEND fpzip_public_defs FPZIP_SHARED_LIBS)
  list(APPEND fpzip_private_defs FPZIP_SOURCE)
endif()

target_compile_definitions(fpzip
  PRIVATE ${fpzip_private_defs}
  PUBLIC ${fpzip_public_defs}
)

target_include_directories(fpzip
  PUBLIC
    $<BUILD_INTERFACE:${FPZIP_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

set_property(TARGET fpzip PROPERTY VERSION ${FPZIP_VERSION})
set_property(TARGET fpzip PROPERTY SOVERSION ${FPZIP_VERSION_MAJOR})
set_property(TARGET fpzip PROPERTY OUTPUT_NAME ${FPZIP_LIBRARY_PREFIX}fpzip)

install(TARGETS fpzip EXPORT fpzip-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Makefile ===
include ../Config

LIBDIR = ../lib
TARGETS = $(LIBDIR)/libfpzip.a $(LIBDIR)/libfpzip.so
OBJECTS = error.o rcdecoder.o rcencoder.o rcqsmodel.o read.o version.o write.o

static: $(LIBDIR)/libfpzip.a

shared: $(LIBDIR)/libfpzip.so

clean:
	rm -f $(TARGETS) $(OBJECTS)

$(LIBDIR)/libfpzip.a: $(OBJECTS)
	mkdir -p $(LIBDIR)
	rm -f $@
	ar rc $@ $^

$(LIBDIR)/libfpzip.so: $(OBJECTS)
	mkdir -p $(LIBDIR)
	$(CXX) $(CXXFLAGS) -shared $^ -o $@

.cpp.o:
	$(CXX) $(CXXFLAGS) -c $<

=== tests/CMakeLists.txt ===
add_executable(testfpzip testfpzip.c)
target_link_libraries(testfpzip fpzip)
if(HAVE_LIBM_MATH)
  target_link_libraries(testfpzip m)
endif()
add_test(NAME compress-decompress-validate COMMAND testfpzip)

=== tests/Makefile ===
include ../Config

BINDIR = ../bin
LIBDIR = ../lib
TARGET = $(BINDIR)/testfpzip

all: $(TARGET)

$(TARGET): testfpzip.c ../lib/$(LIBFPZIP)
	mkdir -p ../bin
	$(CC) $(CFLAGS) testfpzip.c -L$(LIBDIR) -lfpzip -lstdc++ -o $(TARGET)

test: $(BINDIR)/testfpzip
	$(BINDIR)/testfpzip

clean:
	rm -f $(TARGET)

=== utils/CMakeLists.txt ===
add_executable(fpzipcmd fpzip.cpp)
if(NOT MSVC)
  set_property(TARGET fpzipcmd PROPERTY OUTPUT_NAME fpzip)
endif()
target_link_libraries(fpzipcmd fpzip)
if(HAVE_LIBM_MATH)
  target_link_libraries(fpzipcmd m)
endif()

=== utils/Makefile ===
include ../Config

TARGET = ../bin/fpzip

all: $(TARGET)

$(TARGET): fpzip.cpp ../lib/$(LIBFPZIP)
	mkdir -p ../bin
	$(CXX) $(CXXFLAGS) fpzip.cpp -L../lib -lfpzip -o $(TARGET)

clean:
	rm -f $(TARGET)

=== debian/changelog ===
fpzip (1.3.0-6) unstable; urgency=medium

  * cmake-version.patch: Fix FTBFS with CMake 4. Closes: #1112929
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Sep 2025 10:34:20 +0100

fpzip (1.3.0-5) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Drop B-D on dh-buildinfo

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 14 Feb 2025 10:22:48 +0000

fpzip (1.3.0-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix broken Vcs URL.

  [ Alastair McKinstry ]
  * Standards-Version: 4.6.2
  * Set architecture-is-64-bit, tests fail on 32-bit. Closes: #1068067

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Apr 2024 11:37:03 +0100

fpzip (1.3.0-3) unstable; urgency=medium

  * Define int64/uint64 for 32-bit arch build failures
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Apr 2022 11:16:41 +0100

fpzip (1.3.0-2) unstable; urgency=medium

  * Set libpath so test will build without libfpzip installed.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Jan 2021 09:31:17 +0000

fpzip (1.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #980113)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jan 2021 11:27:56 +0000

=== debian/control ===
Source: fpzip
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13),
 architecture-is-64-bit,
 cmake
Standards-Version: 4.7.2
Homepage: https://github.com/LLNL/fpzip
Vcs-Browser: https://salsa.debian.org/science-team/fpzip.git
Vcs-Git: https://salsa.debian.org/science-team/fpzip.git -b debian/latest

Package: fpzip-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfpzip1 ( = ${binary:Version})
Description: FP array compression library - tools
 fpzip is a library and command-line utility for lossless and optionally lossy
 compression of 2D and 3D floating-point arrays.  fpzip assumes spatially
 correlated scalar-valued data, such as regularly sampled continuous functions,
 and is not suitable for compressing unstructured streams of floating-point
 numbers.
 This package provides command-line utilities.

Package: libfpzip1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: FP array compression library
 fpzip is a library and command-line utility for lossless and optionally lossy
 compression of 2D and 3D floating-point arrays.  fpzip assumes spatially
 correlated scalar-valued data, such as regularly sampled continuous functions,
 and is not suitable for compressing unstructured streams of floating-point
 numbers.
 This package provides the shared library.

Package: libfpzip-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libfpzip1 (= ${binary:Version})
Multi-Arch: same
Description: Development files for the FP array compression library
 fpzip is a library and command-line utility for lossless and optionally lossy
 compression of 2D and 3D floating-point arrays.  fpzip assumes spatially
 correlated scalar-valued data, such as regularly sampled continuous functions,
 and is not suitable for compressing unstructured streams of floating-point
 numbers.
 This package provides the headers and static library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1


# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DESTDIR=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH:= $(shell dpkg-architecture -qDEB_TARGET_GNU_TYPE)

export LD_LIBRARY_PATH:=$(CURDIR)/obj-$(TARGET_ARCH)/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH)

ARCH32:= powerpc armel armhf i386 mipsel m68k mips powerpcspe x32
LONG_32BIT:=     $(if $(filter $(DEB_TARGET_ARCH), $(PATCH_ON_32BIT_ARCH)),\
                -DFPZIP_INT64='long long' \
                -DFPZIP_UINT64='long long' \
                -DFPZIP_INT64_SUFFIX='ll' \
                -DFPZIP_UINT64_SUFFIX='ull' , )

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_ALL=On \
		$(LONG_32BIT) \
		-DCMAKE_SKIP_INSTALL_RPATH=On \
		-DCMAKE_SKIP_RPATH=On

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/ \
  https://github.com/LLNL/fpzip/tags .*/(\d\S+)\.tar\.gz
